#ifndef TBUFSRV_H_
#define TBUFSRV_H_

#include "tine.h"
#include "listener.h"

#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#if defined(TBUFSRVDLL_EXPORTS) || defined(TBUFSRV64_EXPORTS)
# define EXPORT_B __declspec(dllexport) 
#endif 
#if defined(TBUFSRVDLL_IMPORTS) || defined(TBUFSRV64_IMPORTS)
# define EXPORT_B __declspec(dllimport) 
#endif
#ifndef EXPORT_B
# define EXPORT_B 
#endif

EXPORT_B int AttachServer(char *srvExportName,char *srvEQPName,int ndevices);
EXPORT_B int AttachServerEx(char *srvExportName,char *srvEQPName,int ndevices,void (*tmr)(void),int tmrInterval);
EXPORT_B void runServer(void);
EXPORT_B int pushBufferedData(char *prpName,char *devName,BYTE *prpData,long prpSiz,int prpSchedule);
EXPORT_B int pullBufferedData(char *prpName,char *devName,BYTE *prpData,long prpSiz);
EXPORT_B int hasInputChanged(char *prpName);
EXPORT_B int RegisterServerCallback(char *prpName, int (*cb)(void));
EXPORT_B int GetInputDeviceNumber(void);
EXPORT_B int RegisterServerNotifierEx(char *prpName, void (*nf)(int), int nid);
EXPORT_B int RegisterServerNotifier(char *prpName, void (*nf)(int));
EXPORT_B int GetRegisteredProperties(NAME32 *prps, short *nprps);
EXPORT_B void TerminateServer();
EXPORT_B int SetBufferedCompletion(int compCode);
EXPORT_B int RegisterBufferedProperty
(
  char *prpName, long prpInSiz, short prpInFmt, long prpOutSiz, short prpOutFmt,
  float prpMax, float prpMin, char *prpEgu,	short access, char *prpDsc
);
EXPORT_B int RegisterBufferedPropertyEx
(
  char *prpName, long prpInSiz, short prpInFmt, long prpOutSiz, short prpOutFmt,
  float prpMax, float prpMin, char *prpEgu,	short access, char *prpDsc, int prpId
);
EXPORT_B int GetRegisteredPropertyInformation
(
  char *eqm, char *prp, /* input */
  float *max, float *min,char *units,
  int *sizeOut, int *sizeIn, char *fmtOut, char *fmtIn,
  char *description
);
EXPORT_B int getNotifiedProperty(char *prpName);
EXPORT_B int getNotifiedPropertyAndDevice(char *prpName,char *devName);
EXPORT_B void SetNotifierDeadband(int timeInMilliseconds);
EXPORT_B int RegisterCycleTriggerNotifier(void (*nf)(int), int nid);
EXPORT_B int GetTriggerCycle(int *cycleNumber,int *cycleStatus);
EXPORT_B int TriggerEvent(char *devname,char *cmt,short triggerLevel);

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* TBUFSRV_H_ */
