#ifndef _TINEDEFS_H_
#define _TINEDEFS_H_

#include "project.def"
#if defined(__cplusplus) && !defined(FORCE_CPP)
extern "C" {
#endif

#ifdef VXWORKS
# ifndef MULTITHREADED
#   define MULTITHREADED
# endif
#endif

#ifndef TINE_EXPORT
# define TINE_EXPORT
#endif

#ifndef CNTXT_PREFIX
#define CNTXT_PREFIX "\\\\"
#endif

#ifndef DELIMITER
#define DELIMITER "/\\"
#endif

/** 
 * \brief Direction: Local to Local flag (no byte swapping)
 */
#ifndef LTOL
# define LTOL   -1
#endif
/** 
 * \brief Direction: Remote to Local flag
 */
#ifndef RTOL
# define RTOL    0
#endif
/**
 * \brief  Direction: Local to Remote flag
 */  
#ifndef LTOR
# define LTOR    1  
#endif


#ifndef MAX
/** 
 * \brief Returns the greater of two variables.
 */
#define MAX(a,b)  ((a) > (b) ? a : b)
#endif

#ifndef MIN
/**
 * \brief Returns the lesser of two variables 
 */
#define MIN(a,b)  ((a) < (b) ? a : b) 
#endif

#ifndef BYTE
#define BYTE unsigned char
#endif
#ifndef UINT8
#define UINT8 unsigned char
#endif
#ifndef SINT16
#define SINT16 short
#endif
#ifndef UINT16
#define UINT16 unsigned short
#endif
#ifndef UINT32
#define UINT32 unsigned int
#endif
#ifndef SINT32
#define SINT32 int
#endif
#ifndef WIN32
#ifndef WORD
#define WORD UINT16
#endif
#ifndef DWORD
#define DWORD UINT32
#endif
#endif

#ifndef TRUE
/**
 * \brief Definition of logical True 
 */
#define TRUE -1
#endif

#ifndef FALSE
/**
 * \brief Definition of logical False 
 */
#define FALSE 0
#endif

#ifndef TINE_DECORATED_CONSTANTS

#undef CF_TEXT
#define CF_DOUBLE       512
#define CF_INT16        513
#define CF_SHORT        513
#define CF_INTEGER      513
#define CF_INT8         514
#define CF_BYTE         514
#define CF_INT32        515
#define CF_LONG         515
#define CF_TEXT         516
#define CF_CHAR         516
#define CF_FLOAT        517
#define CF_INT64        518
#define CF_DLONG        518
#define CF_STRUCT       519
#define CF_CHAR8        520
#define CF_NAME8        520
#define CF_STRING8      520
#define CF_CHAR16       521
#define CF_NAME16       521
#define CF_STRING16     521
#define CF_CHAR16FI     522
#define CF_NAME16FI     522
#define CF_BIT          523
#define CF_HITTS        524
#define CF_CHAR32       525
#define CF_NAME32       525
#define CF_STRING32     525
#define CF_FI           526
#define CF_FLTINT       526
#define CF_II           527
#define CF_LI           527
#define CF_LL           527
#define CF_INTINT       527
#define CF_LNGINT       527
#define CF_DI           528
#define CF_DBLINT       528
#define CF_SI           529
#define CF_SHTINT       529
#define CF_TDS          530
#define CF_IFI          530
#define CF_INTFLTINT    530
#define CF_CHAR48       531
#define CF_NAME48       531
#define CF_STRING48     531
#define CF_CHAR8I       532
#define CF_NAME8I       532
#define CF_CHAR16I      533
#define CF_NAME16I      533
#define CF_CHAR32I      534
#define CF_NAME32I      534
#define CF_CHAR48I      535
#define CF_NAME48I      535

#define CF_USTRING      536
#define CF_XYS          537
#define CF_FFI          537
#define CF_FLTFLTINT    537
#define CF_FII          538
#define CF_FLTINTINT    538
#define CF_FIS          538
#define CF_FILTER       539
#define CF_IFFF         539
#define CF_INTFLTFLTFLT 539
#define CF_SPECTRUM     540
#define CF_ADDRESS      541
#define CF_IIII         541
#define CF_INTINTINTINT 541
#define CF_WINDOW       542
#define CF_TTII         542
#define CF_POINT        543
#define CF_FF           543
#define CF_XY           543
#define CF_FLTFLT       543
#define CF_TDSI         544
#define CF_INTFLTSHTSHT 544
#define CF_BOOLEAN      545
#define CF_IIFF         546
#define CF_INTINTFLTFLT 546
#define CF_FWINDOW      546
#define CF_FIFI         547
#define CF_FLTINTFLTINT 547
#define CF_CHAR64       548
#define CF_NAME64       548
#define CF_STRING64     548
#define CF_CHAR64I      549
#define CF_NAME64I      549
#define CF_INTDBL       550
#define CF_LNGDBL       550
#define CF_FLTDBL       551
#define CF_DBLDBL       552
#define CF_NAMEDBLDBL   553
#define CF_NAME16DBLDBL 553
#define CF_NAME16INTINT 554
#define CF_CHAR16INTINT 554
#define CF_NAME16II     554
#define CF_CHAR16II     554
#define CF_STRING16II   554
#define CF_NAMEII       554
#define CF_INTINTINT    555
#define CF_III          555
#define CF_NAME32DBLDBL 556
#define CF_CHAR32DBLDBL 556
#define CF_STRING32DBLDBL 556
#define CF_NAME64DBLDBL 557
#define CF_CHAR64DBLDBL 557
#define CF_STRING64DBLDBL 557
#define CF_IFFFNAME     558
#define CF_IFFFNAME16   558
#define CF_INTFLTFLTFLTNAME16 558
#define CF_UNAME        558
#define CF_XML          559
#define CF_DBLDBLDBL    560
#define CF_NAME64DBLDBLDBL 561
#define CF_CHAR64DBLDBLDBL 561
#define CF_STRING64DBLDBLDBL 561
#define CF_BITFIELD8    562
#define CF_BITFIELD16   563
#define CF_BITFIELD32   564
#define CF_BITFIELD64   565
#define CF_NAME64DBL    566
#define CF_CHAR64DBL    566
#define CF_STRING64DBL  566
#define CF_IMAGE        567
#define CF_HISTORY      568
#define CF_STRING       569
#define CF_ASPECTRUM    570
#define CF_AIMAGE       571

#define CF_DEFAULT      766
#undef CF_NULL
#define CF_NULL     767

#define HISTORY_HDR_SIZE 16
#define SPECTRUM_HDR_SIZE 96
#define SPECTRUM_STD_SIZE 4096
#define IMAGE_HDR_SIZE 188
#define IMAGE_STD_FRAMESIZE 500000
#define STRING_STD_CAPACITY 128

#define LFMT(fmt) (((fmt)%256)+CF_DOUBLE)
#define BFMT(fmt) ((fmt)%256)

#define getFormatHeaderSize(fmt)\
 ( fmt == CF_SPECTRUM ? SPECTRUM_HDR_SIZE :\
   fmt == CF_ASPECTRUM ? SPECTRUM_HDR_SIZE :\
   fmt == CF_IMAGE ? IMAGE_HDR_SIZE :\
   fmt == CF_AIMAGE ? IMAGE_HDR_SIZE : 0 )

#define getFormatDataType(fmt)\
 ( fmt == CF_SPECTRUM ? CF_FLOAT :\
   fmt == CF_ASPECTRUM ? CF_FLOAT :\
   fmt == CF_IMAGE ? CF_BYTE :\
   fmt == CF_AIMAGE ? CF_BYTE : fmt )

#define getFormatBodyPtr(dst,fmt)\
 ( fmt == CF_IMAGE ? ((DIMAGE *)dst)->frameBuffer :\
   fmt == CF_AIMAGE ? ((DIMAGE *)dst)->frameBuffer :\
   fmt == CF_ASPECTRUM ? (BYTE *)((ASPECTRUM *)dst)->spectBuffer : NULL)

#define getFormatBodyPtrAddr(dst,fmt)\
 ( fmt == CF_IMAGE ? &(((DIMAGE *)dst)->frameBuffer) :\
   fmt == CF_AIMAGE ? &(((DIMAGE *)dst)->frameBuffer) :\
   fmt == CF_ASPECTRUM ? (BYTE **)&(((ASPECTRUM *)dst)->spectBuffer) : NULL)

#define getFormatBodyBufferSize(dst,fmt)\
 ( fmt == CF_IMAGE ? ((DIMAGE *)dst)->frameBufferSize :\
   fmt == CF_AIMAGE ? ((DIMAGE *)dst)->frameBufferSize :\
   fmt == CF_ASPECTRUM ? ((ASPECTRUM *)dst)->spectBufferSize : 0)

#define getFormatBodyBufferSizeAddr(dst,fmt)\
 ( fmt == CF_IMAGE ? &((DIMAGE *)dst)->frameBufferSize :\
   fmt == CF_AIMAGE ? &((DIMAGE *)dst)->frameBufferSize :\
   fmt == CF_ASPECTRUM ? &((ASPECTRUM *)dst)->spectBufferSize : 0)

#define getFormatTypeSize(fmt)\
 ( fmt == CF_SPECTRUM ? sizeof(DSPECTRUM) :\
   fmt == CF_ASPECTRUM ? sizeof(ASPECTRUM) :\
   fmt == CF_IMAGE ? sizeof(DIMAGE) :\
   fmt == CF_AIMAGE ? sizeof(DIMAGE) : fmtsizeof(fmt) )

#define getFormatStandardCapacity(fmt)\
 ( fmt == CF_SPECTRUM ? SPECTRUM_STD_SIZE :\
   fmt == CF_ASPECTRUM ? SPECTRUM_STD_SIZE :\
   fmt == CF_IMAGE ? IMAGE_STD_FRAMESIZE :\
   fmt == CF_AIMAGE ? IMAGE_STD_FRAMESIZE :\
   fmt == CF_STRING ? STRING_STD_CAPACITY : 1 )

TINE_EXPORT int GetFormatSize(int fmt);
#define getFormatSize(a1) GetFormatSize(a1)
#define fmtsizeof(fmt) getFormatSize(((fmt)%256)+CF_DOUBLE)

#define isPrimitiveFormat(fmt) (fmt <= CF_INT64 ? TRUE : FALSE)
int isIntegerFormat(short fmt);
int isSimpleFormat(short fmt);
int isSimpleStringFormat(short fmt);
int isStringFormat(short fmt);
int isTaggableFormat(short fmt);
int getCarriedFormatSize(char *tag);
int isVariableLengthFormat(short fmt);
int isAdjustableLengthFormat(short fmt);

#define getSimpleFormatType(txt) (\
  !strcmp(txt,"INT8")     ? CF_BYTE :\
  !strcmp(txt,"BYTE")     ? CF_BYTE :\
  !strcmp(txt,"SHORT")    ? CF_SHORT :\
   strstr(txt,"INT16")    ? CF_SHORT :\
  !strcmp(txt,"INTEGER")  ? CF_SHORT :\
  !strcmp(txt,"LONG")     ? CF_LONG :\
   strstr(txt,"INT32")    ? CF_LONG :\
  !strcmp(txt,"FLOAT")    ? CF_FLOAT :\
  !strcmp(txt,"SINGLE")   ? CF_FLOAT :\
  !strcmp(txt,"DOUBLE")   ? CF_DOUBLE :\
  !strcmp(txt,"DLONG")    ? CF_INT64 :\
   strstr(txt,"INT64")    ? CF_INT64 :\
  !strcmp(txt,"STRUCT")   ? CF_STRUCT :\
  !strcmp(txt,"TEXT")     ? CF_TEXT :\
  !strcmp(txt,"CHAR")     ? CF_TEXT :\
  !strcmp(txt,"STRING")   ? CF_STRING :\
  !strcmp(txt,"NAME8")    ? CF_CHAR8 :\
  !strcmp(txt,"CHAR8")    ? CF_CHAR8 :\
  !strcmp(txt,"NAME16")   ? CF_CHAR16 :\
  !strcmp(txt,"CHAR16")   ? CF_CHAR16 :\
  !strcmp(txt,"CHAR32")   ? CF_CHAR32 :\
  !strcmp(txt,"NAME32")   ? CF_CHAR32 :\
  !strcmp(txt,"CHAR48")   ? CF_CHAR48 :\
  !strcmp(txt,"NAME48")   ? CF_CHAR48 :\
  !strcmp(txt,"CHAR64")   ? CF_CHAR64 :\
  !strcmp(txt,"NAME64")   ? CF_CHAR64 :\
  !strcmp(txt,"BIT")      ? CF_BIT :\
  !strcmp(txt,"BOOLEAN")  ? CF_BOOLEAN  :\
  !strcmp(txt,"XML")      ? CF_XML :\
  CF_NULL )

#define getCompoundFormatType(txt) (\
  !strcmp(txt,"NAME16FLTINT") ? CF_CHAR16FI :\
  !strcmp(txt,"NAME16FI") ? CF_CHAR16FI :\
  !strcmp(txt,"CHAR16FI") ? CF_CHAR16FI :\
  !strcmp(txt,"NAME8I")   ? CF_CHAR8I :\
  !strcmp(txt,"CHAR8I")   ? CF_CHAR8I :\
  !strcmp(txt,"NAME16I")  ? CF_CHAR16I :\
  !strcmp(txt,"CHAR16I")  ? CF_CHAR16I :\
  !strcmp(txt,"NAME32I")  ? CF_CHAR32I :\
  !strcmp(txt,"CHAR32I")  ? CF_CHAR32I :\
  !strcmp(txt,"NAME48I")  ? CF_CHAR48I :\
  !strcmp(txt,"CHAR48I")  ? CF_CHAR48I :\
  !strcmp(txt,"NAME64I")  ? CF_CHAR64I :\
  !strcmp(txt,"CHAR64I")  ? CF_CHAR64I :\
  !strcmp(txt,"HITTS")    ? CF_HITTS :\
  !strcmp(txt,"FI")       ? CF_FI :\
  !strcmp(txt,"FLTINT")   ? CF_FI :\
  !strcmp(txt,"FLTDBL")   ? CF_FLTDBL :\
  !strcmp(txt,"II")       ? CF_II :\
  !strcmp(txt,"INTINT")   ? CF_II :\
  !strcmp(txt,"LI")       ? CF_II :\
  !strcmp(txt,"LNGINT")   ? CF_II :\
  !strcmp(txt,"LNGDBL")   ? CF_LNGDBL :\
  !strcmp(txt,"INTDBL")   ? CF_LNGDBL :\
  !strcmp(txt,"DBLDBL")   ? CF_DBLDBL :\
  !strcmp(txt,"NAMEDBLDBL") ? CF_NAMEDBLDBL :\
  !strcmp(txt,"NAME16DBLDBL") ? CF_NAMEDBLDBL :\
  !strcmp(txt,"NAME32DBLDBL") ? CF_NAME32DBLDBL :\
  !strcmp(txt,"NAME64DBL") ? CF_NAME64DBL :\
  !strcmp(txt,"NAME64DBLDBL") ? CF_NAME64DBLDBL :\
  !strcmp(txt,"NAME64DBLDBLDBL") ? CF_NAME64DBLDBLDBL :\
  !strcmp(txt,"NAME16II") ? CF_NAME16II :\
  !strcmp(txt,"CHAR16II") ? CF_NAME16II :\
  !strcmp(txt,"NAME16INTINT") ? CF_NAME16II :\
  !strcmp(txt,"DBLDBLDBL")   ? CF_DBLDBLDBL :\
  !strcmp(txt,"TDS")      ? CF_TDS :\
  !strcmp(txt,"IFI")      ? CF_TDS :\
  !strcmp(txt,"INTFLTINT")? CF_TDS :\
  !strcmp(txt,"USTRING")  ? CF_USTRING :\
  !strcmp(txt,"XYS")      ? CF_XYS :\
  !strcmp(txt,"FFI")      ? CF_XYS :\
  !strcmp(txt,"FLTFLTINT")? CF_XYS :\
  !strcmp(txt,"FLTINTINT")? CF_FII :\
  !strcmp(txt,"FIS")      ? CF_FII :\
  !strcmp(txt,"FILTER")   ? CF_FILTER :\
  !strcmp(txt,"IFFF")     ? CF_IFFF :\
  !strcmp(txt,"INTFLTFLTFLT")? CF_IFFF :\
  !strcmp(txt,"SPECTRUM") ? CF_SPECTRUM :\
  !strcmp(txt,"ASPECTRUM") ? CF_ASPECTRUM :\
  !strcmp(txt,"ADDRESS")  ? CF_ADDRESS  :\
  !strcmp(txt,"INTINTINTINT")? CF_ADDRESS  :\
  !strcmp(txt,"IIII")     ? CF_ADDRESS  :\
  !strcmp(txt,"INTINTINT")? CF_III  :\
  !strcmp(txt,"III")      ? CF_III  :\
  !strcmp(txt,"WINDOW")   ? CF_WINDOW  :\
  !strcmp(txt,"TTII")     ? CF_WINDOW  :\
  !strcmp(txt,"POINT")    ? CF_POINT  :\
  !strcmp(txt,"XY")       ? CF_POINT  :\
  !strcmp(txt,"FLTFLT")   ? CF_POINT  :\
  !strcmp(txt,"TDSI")     ? CF_TDSI  :\
  !strcmp(txt,"INTFLTSHTSHT")? CF_TDSI  :\
  !strcmp(txt,"DEFAULT")  ? CF_DEFAULT :\
  !strcmp(txt,"IIFF")     ? CF_IIFF :\
  !strcmp(txt,"INTINTFLTFLT")? CF_IIFF :\
  !strcmp(txt,"FIFI")     ? CF_FIFI :\
  !strcmp(txt,"FLTINTFLTINT")? CF_FIFI :\
  !strcmp(txt,"FWINDOW")   ? CF_FWINDOW  :\
  !strcmp(txt,"IFFFNAME")   ? CF_IFFFNAME  :\
  !strcmp(txt,"INTFLTFLTFLTNAME") ? CF_IFFFNAME  :\
  !strcmp(txt,"UNAME") ? CF_IFFFNAME  :\
  !strcmp(txt,"BITFIELD8") ? CF_BITFIELD8  :\
  !strcmp(txt,"BITFIELD16") ? CF_BITFIELD16 :\
  !strcmp(txt,"BITFIELD32") ? CF_BITFIELD32 :\
  !strcmp(txt,"IMAGE") ? CF_IMAGE :\
  !strcmp(txt,"AIMAGE") ? CF_AIMAGE :\
  !strcmp(txt,"HISTORY") ? CF_HISTORY :\
  CF_NULL )

#define CM_NULL         0x00
#define CM_CANCEL       0x00
#define CM_SINGLE       0x01
#define CM_REFRESH      0x02
#define CM_DATACHANGE   0x02
#define CM_POLL         0x03
#define CM_TIMER        0x03
#define CM_REGISTER     0x04
#define CM_RECEIVE      0x05
#define CM_EVENT        0x06
#define CM_NODUPLICATES 0x10
#define CM_SEEKPATTERN  0x20
#define CM_MISSPATTERN  0x40
#define CM_STREAM       0x80
#define CM_SYNCGROUP    0x100
#define CM_BCAST        0x200
#define CM_NETWORK      0x200
#define CM_MCAST        0x200
#define CM_USE_ON_ERROR 0x400
#define CM_USEONERROR   0x400
#define CM_RETRY        0x800
#define CM_GROUPED      0x1000
#define CM_CONNECT      0x2000
#define CM_WAIT         0x4000
#define CM_SYNCNOTIFY   0x8000

#define BASEMODE(m)  ((m) & 0x07)
#define TARGETMODE(m)  ((m) & 0x0f7f)
#define CM_REMOVEVOLATILE (CM_NODUPLICATES|CM_SEEKPATTERN|CM_MISSPATTERN|CM_USEONERROR|CM_GROUPED|CM_SYNCGROUP|CM_WAIT)

#define getAccessMode(txt) (\
	strstr(txt,"READ")    ? CM_SINGLE :\
	strstr(txt,"WRITE")   ? CM_SINGLE :\
	strstr(txt,"SINGLE")  ? CM_SINGLE :\
	strstr(txt,"REFRESH") ? CM_DATACHANGE :\
	strstr(txt,"DATACHANGE") ? CM_DATACHANGE :\
	strstr(txt,"POLL")    ? CM_TIMER :\
	strstr(txt,"TIMER")   ? CM_TIMER :\
	strstr(txt,"REGISTER")? CM_REGISTER :\
	strstr(txt,"RECEIVE") ? CM_RECEIVE :\
	strstr(txt,"EVENT")   ? CM_EVENT :\
	CM_CANCEL )
short getTransferMode(char *mod);
extern char *modetoa[];
TINE_EXPORT char *GetModeAsString(int transferMode);
TINE_EXPORT short GetTransferMode(char *mod);

/* first byte of assigned access in carried in the call */
#define CA_NULL         0x00 /**< unassigned */
#define CA_READ         0x01 /**< READ access (cln and srv) */
#define CA_WRITE        0x02 /**< WRITE access (cln and srv) */
#define CA_REPEAT       0x04 /**< call is being repeated (srv: passed to eqm) */
#define CA_SYNC         0x08 /**< call is marked synchronous (cln: guarantee sync) */
#define CA_ALARM        0x10 /**< call is from local alarm system (srv: passed to eqm) */
#define CA_HIST         0x20 /**< call is from local history system (srv: passed to eqm) */
#define CA_FIRST        0x40 /**< link is coming into scope (srv: passed to eqm) */
#define CA_LAST         0x80 /**< link is going out of scope (srv: passed to eqm) */
#define CA_STATIC       0x80 /**< property registration contains static information */
#define CA_RETRY        0x100 /**< call should retry on timeout (cln: passed to link call) */
#define CA_NETWORK      0x200 /**< property registration enforces NETWORK access */
#define CA_QUERY        0x400 /**< call is an internal query (srv: passed to eqm) */
#define CA_SINGLE       0x400 /**< signal that access is single synchronous (contract interpretation) */
#define CA_CCSHOWALL    0x400 /**< sync call should pass all relevant completion code flags (cln: passed to link call) */
#define CA_LOCKED       0x800 /**< call has an access lock (srv: passed to eqm) */
#define CA_STREAM       0x800 /**< sync call should use CM_STREAM access (cln: passed to link call) */
#define CA_XREAD        0x800 /**< property registration requests exclusive READ access */
#define CA_NORETRY      0x1000 /**< call should NOT retry on timeout (cln: passed to link call) */
#define CA_NOSYNC       0x1000 /**< property registration enforces asynchronous access */
#define CA_CONNECT      0x2000 /**< sync call should use CM_CONNECT access (cln: passed to link call) */
#define CA_MUTABLE      0x4000 /**< sync call can change the input parameters (cln: passed to link call) */
#define CA_SAVERESTORE  0x4000 /**< property registration signals save-and-restore property */
#define CA_SYNCNOTIFY   0x8000 /**< async callbacks should not be deferred (cln: passed to link call) */

#define CA_SENDCODE     0x8000 /**< special signal for scheduling (srv: passed to SystemSchedulePropertyEx) */
#define CA_FIX          0xff /**< special signal for property query functions */

#define getAccessType(txt) ( strstr(txt,"WRITE") ? CA_WRITE : CA_READ )

short ftoi(char *fmt);
#define getFormatType(f) ftoi(f)
char *itof(int fmt);
short mtoi(char *mod);
char *itom(short accessMode);
TINE_EXPORT char *GetFormatAsString(int fmt);
TINE_EXPORT short GetFormatFromString(char *fmt);

#define GT_LIN  0
#define GT_LOG  1
#define GT_SLOG 2
#define GT_TD   3
#define GT_BIT  4
#define GT_TEXT 5
#define GT_ABS  6
#define GT_HEX  7

#define getGraphType(txt) (\
  txt == NULL           ? GT_LIN:\
  strstr(txt,"LIN")     ? GT_LIN :\
  strstr(txt,"LOG")     ? GT_LOG :\
  strstr(txt,"SLOG")    ? GT_SLOG :\
  strstr(txt,"TD")      ? GT_TD :\
  strstr(txt,"BIT")     ? GT_BIT :\
  strstr(txt,"TEXT")    ? GT_TEXT :\
  strstr(txt,"ABS")     ? GT_ABS :\
  strstr(txt,"HEX")     ? GT_HEX :\
  GT_LIN )

#define AT_UNKNOWN      0x00
#define AT_SCALAR       0x01
#define AT_SINGLE       0x02
#define AT_DOUBLE       0x04
#define AT_BOOLEAN      0x08
#define AT_CHANNEL      0x10
#define AT_SPECTRUM     0x20
#define AT_TRACE        0x20
#define AT_WAVEFORM     0x20
#define AT_STRUCTURED   0x40
#define AT_COLLECTION   0x40
#define AT_UNSTRUCTURED 0x80
#define AT_BLOB         0x80
#define AT_IMAGE        0x80
#define AT_JPEG        0x100
#define AT_MPEG        0x200
#define AT_BMP         0x400
#define AT_GIF         0x800
#define AT_WAV        0x1000
#define AT_MP3        0x2000

short getArrayType(char *fmt);
short getArrayRowLength(char *fmt);
TINE_EXPORT short GetArrayTypeFromString(char *fmt);
TINE_EXPORT char *GetArrayTypeAsString(int type);

/* image format definitions */
#define IF_GRAY   0
#define IF_RGB    1
#define IF_RGBA   2
#define IF_RGB15  3
#define IF_RGB16  4
#define IF_JPEG   5
#define IF_TIFF   6
#define IF_YUV411 7
#define IF_YUV422 8
#define IF_YUV444 9
#define IF_HUFFYUV 10
#define IF_BITMAP 11

/* image flags */
#define IFLG_LITTLE_ENDIAN   0x1
#define IFLG_LOSSLESS_COMP   0x2
#define IFLG_HORIZONTAL_FLIP 0x4
#define IFLG_VERTICAL_FLIP   0x8

/* property signals */
#define PS_NONE    0x00 /**< NULL signal */
#define PS_ACCESS  0x01 /**< property is being accessed by a caller */
#define PS_RETRY   0x02 /**< property is being retried */
#define PS_LATE    0x04 /**< property is being returned late */
#define PS_PENDING 0x08 /**< property is being called while last transmission still pending */
#define PS_SENT    0x10 /**< property has been sent to caller */
#define PS_CALLED  0x20 /**< property has been called and results returned */
#define PS_ALL     0xff /**< signal on any event */

#else /* is defined TINE_DECORATED_CONSTANTS */ 

#define TDC_CF_DOUBLE       512
#define TDC_CF_INT16        513
#define TDC_CF_SHORT        513
#define TDC_CF_INTEGER      513
#define TDC_CF_INT8         514
#define TDC_CF_BYTE         514
#define TDC_CF_INT32        515
#define TDC_CF_LONG         515
#define TDC_CF_TEXT         516
#define TDC_CF_CHAR         516
#define TDC_CF_FLOAT        517
#define TDC_CF_INT64        518
#define TDC_CF_DLONG        518
#define TDC_CF_STRUCT       519
#define TDC_CF_CHAR8        520
#define TDC_CF_NAME8        520
#define TDC_CF_STRING8      520
#define TDC_CF_CHAR16       521
#define TDC_CF_NAME16       521
#define TDC_CF_STRING16     521
#define TDC_CF_CHAR16FI     522
#define TDC_CF_NAME16FI     522
#define TDC_CF_BIT          523
#define TDC_CF_HITTS        524
#define TDC_CF_CHAR32       525
#define TDC_CF_NAME32       525
#define TDC_CF_STRING32     525
#define TDC_CF_FI           526
#define TDC_CF_FLTINT       526
#define TDC_CF_II           527
#define TDC_CF_LI           527
#define TDC_CF_LL           527
#define TDC_CF_INTINT       527
#define TDC_CF_LNGINT       527
#define TDC_CF_DI           528
#define TDC_CF_DBLINT       528
#define TDC_CF_SI           529
#define TDC_CF_SHTINT       529
#define TDC_CF_TDS          530
#define TDC_CF_IFI          530
#define TDC_CF_INTFLTINT    530
#define TDC_CF_CHAR48       531
#define TDC_CF_NAME48       531
#define TDC_CF_STRING48     531
#define TDC_CF_CHAR8I       532
#define TDC_CF_NAME8I       532
#define TDC_CF_CHAR16I      533
#define TDC_CF_NAME16I      533
#define TDC_CF_CHAR32I      534
#define TDC_CF_NAME32I      534
#define TDC_CF_CHAR48I      535
#define TDC_CF_NAME48I      535

#define TDC_CF_USTRING      536
#define TDC_CF_XYS          537
#define TDC_CF_FFI          537
#define TDC_CF_FLTFLTINT    537
#define TDC_CF_FII          538
#define TDC_CF_FLTINTINT    538
#define TDC_CF_FIS          538
#define TDC_CF_FILTER       539
#define TDC_CF_IFFF         539
#define TDC_CF_INTFLTFLTFLT 539
#define TDC_CF_SPECTRUM     540
#define TDC_CF_ADDRESS      541
#define TDC_CF_IIII         541
#define TDC_CF_INTINTINTINT 541
#define TDC_CF_WINDOW       542
#define TDC_CF_TTII         542
#define TDC_CF_POINT        543
#define TDC_CF_FF           543
#define TDC_CF_XY           543
#define TDC_CF_FLTFLT       543
#define TDC_CF_TDSI         544
#define TDC_CF_INTFLTSHTSHT 544
#define TDC_CF_BOOLEAN      545
#define TDC_CF_IIFF         546
#define TDC_CF_INTINTFLTFLT 546
#define TDC_CF_FWINDOW      546
#define TDC_CF_FIFI         547
#define TDC_CF_FLTINTFLTINT 547
#define TDC_CF_CHAR64       548
#define TDC_CF_NAME64       548
#define TDC_CF_STRING64     548
#define TDC_CF_CHAR64I      549
#define TDC_CF_NAME64I      549
#define TDC_CF_INTDBL       550
#define TDC_CF_LNGDBL       550
#define TDC_CF_FLTDBL       551
#define TDC_CF_DBLDBL       552
#define TDC_CF_NAMEDBLDBL   553
#define TDC_CF_NAME16DBLDBL 553
#define TDC_CF_NAME16INTINT 554
#define TDC_CF_CHAR16INTINT 554
#define TDC_CF_NAME16II     554
#define TDC_CF_CHAR16II     554
#define TDC_CF_STRING16II   554
#define TDC_CF_NAMEII       554
#define TDC_CF_INTINTINT    555
#define TDC_CF_III          555
#define TDC_CF_NAME32DBLDBL 556
#define TDC_CF_CHAR32DBLDBL 556
#define TDC_CF_STRING32DBLDBL 556
#define TDC_CF_NAME64DBLDBL 557
#define TDC_CF_CHAR64DBLDBL 557
#define TDC_CF_STRING64DBLDBL 557
#define TDC_CF_IFFFNAME     558
#define TDC_CF_IFFFNAME16   558
#define TDC_CF_INTFLTFLTFLTNAME16 558
#define TDC_CF_UNAME        558
#define TDC_CF_XML          559
#define TDC_CF_DBLDBLDBL    560
#define TDC_CF_NAME64DBLDBLDBL 561
#define TDC_CF_CHAR64DBLDBLDBL 561
#define TDC_CF_STRING64DBLDBLDBL 561
#define TDC_CF_BITFIELD8    562
#define TDC_CF_BITFIELD16   563
#define TDC_CF_BITFIELD32   564
#define TDC_CF_BITFIELD64   565
#define TDC_CF_NAME64DBL    566
#define TDC_CF_CHAR64DBL    566
#define TDC_CF_STRING64DBL  566
#define TDC_CF_IMAGE        567
#define TDC_CF_HISTORY      568
#define TDC_CF_STRING       569
#define TDC_CF_ASPECTRUM    570
#define TDC_CF_AIMAGE       571
#define TDC_CF_DEFAULT      766
#undef TDC_CF_NULL
#define TDC_CF_NULL     767

#define HISTORY_HDR_SIZE 16
#define SPECTRUM_HDR_SIZE 96
#define SPECTRUM_STD_SIZE 4096
#define IMAGE_HDR_SIZE 188
#define IMAGE_STD_FRAMESIZE 500000
#define STRING_STD_CAPACITY 128

#define LFMT(fmt) (((fmt)%256)+TDC_CF_DOUBLE)
#define BFMT(fmt) ((fmt)%256)

#define getFormatHeaderSize(fmt)\
 ( fmt == TDC_CF_SPECTRUM ? SPECTRUM_HDR_SIZE :\
   fmt == TDC_CF_ASPECTRUM ? SPECTRUM_HDR_SIZE :\
   fmt == TDC_CF_IMAGE ? IMAGE_HDR_SIZE :\
   fmt == TDC_CF_AIMAGE ? IMAGE_HDR_SIZE : 0 )

#define getFormatDataType(fmt)\
 ( fmt == TDC_CF_SPECTRUM ? TDC_CF_FLOAT :\
   fmt == TDC_CF_ASPECTRUM ? TDC_CF_FLOAT :\
   fmt == TDC_CF_IMAGE ? TDC_CF_BYTE :\
   fmt == TDC_CF_AIMAGE ? TDC_CF_BYTE : fmt )

#define getFormatBodyPtr(dst,fmt)\
 ( fmt == TDC_CF_IMAGE ? ((DIMAGE *)dst)->frameBuffer :\
   fmt == TDC_CF_AIMAGE ? ((DIMAGE *)dst)->frameBuffer : NULL)

#define getFormatBodyPtrAddr(dst,fmt)\
 ( fmt == TDC_CF_IMAGE ? &(((DIMAGE *)dst)->frameBuffer) :\
   fmt == TDC_CF_AIMAGE ? &(((DIMAGE *)dst)->frameBuffer) :\
   fmt == TDC_CF_ASPECTRUM ? &(((ASPECTRUM *)dst)->spectBuffer) : NULL)

#define getFormatBodyBufferSize(dst,fmt)\
 ( fmt == TDC_CF_IMAGE ? ((DIMAGE *)dst)->frameBufferSize :\
   fmt == TDC_CF_AIMAGE ? ((DIMAGE *)dst)->frameBufferSize : 0)

#define getFormatBodyBufferSizeAddr(dst,fmt)\
 ( fmt == TDC_CF_IMAGE ? &((DIMAGE *)dst)->frameBufferSize :\
   fmt == TDC_CF_AIMAGE ? &((DIMAGE *)dst)->frameBufferSize :\
   fmt == TDC_CF_ASPECTRUM ? &((ASPECTRUM *)dst)->spectBufferSize : 0)

#define getFormatTypeSize(fmt)\
 ( fmt == TDC_CF_SPECTRUM ? sizeof(DSPECTRUM) :\
   fmt == TDC_CF_ASPECTRUM ? sizeof(ASPECTRUM) :\
   fmt == TDC_CF_IMAGE ? sizeof(DIMAGE) :\
   fmt == TDC_CF_AIMAGE ? sizeof(DIMAGE) : fmtsizeof(fmt) )

TINE_EXPORT int GetFormatSize(int fmt);
#define getFormatSize(a1) GetFormatSize(a1)
#define fmtsizeof(fmt) getFormatSize(((fmt)%256)+TDC_CF_DOUBLE)

#define isPrimitiveFormat(fmt) (fmt <= TDC_CF_INT64 ? TRUE : FALSE)
int isIntegerFormat(short fmt);
int isSimpleFormat(short fmt);
int isSimpleStringFormat(short fmt);
int isStringFormat(short fmt);
int isTaggableFormat(short fmt);
int getCarriedFormatSize(char *tag);
int isVariableLengthFormat(short fmt);
int isAdjustableLengthFormat(short fmt);

#define getSimpleFormatType(txt) (\
  !strcmp(txt,"BYTE")     ? TDC_CF_BYTE :\
  !strcmp(txt,"SHORT")    ? TDC_CF_SHORT :\
  !strcmp(txt,"INT16")    ? TDC_CF_SHORT :\
  !strcmp(txt,"INTEGER")  ? TDC_CF_SHORT :\
  !strcmp(txt,"LONG")     ? TDC_CF_LONG :\
  !strcmp(txt,"INT32")    ? TDC_CF_LONG :\
  !strcmp(txt,"FLOAT")    ? TDC_CF_FLOAT :\
  !strcmp(txt,"SINGLE")   ? TDC_CF_FLOAT :\
  !strcmp(txt,"DOUBLE")   ? TDC_CF_DOUBLE :\
  !strcmp(txt,"DLONG")    ? TDC_CF_INT64 :\
  !strcmp(txt,"INT64")    ? TDC_CF_INT64 :\
  !strcmp(txt,"STRUCT")   ? TDC_CF_STRUCT :\
  !strcmp(txt,"TEXT")     ? TDC_CF_TEXT :\
  !strcmp(txt,"CHAR")     ? TDC_CF_TEXT :\
  !strcmp(txt,"STRING")   ? TDC_CF_STRING :\
  !strcmp(txt,"NAME8")    ? TDC_CF_CHAR8 :\
  !strcmp(txt,"CHAR8")    ? TDC_CF_CHAR8 :\
  !strcmp(txt,"NAME16")   ? TDC_CF_CHAR16 :\
  !strcmp(txt,"CHAR16")   ? TDC_CF_CHAR16 :\
  !strcmp(txt,"CHAR32")   ? TDC_CF_CHAR32 :\
  !strcmp(txt,"NAME32")   ? TDC_CF_CHAR32 :\
  !strcmp(txt,"CHAR48")   ? TDC_CF_CHAR48 :\
  !strcmp(txt,"NAME48")   ? TDC_CF_CHAR48 :\
  !strcmp(txt,"CHAR64")   ? TDC_CF_CHAR64 :\
  !strcmp(txt,"NAME64")   ? TDC_CF_CHAR64 :\
  !strcmp(txt,"BIT")      ? TDC_CF_BIT :\
  !strcmp(txt,"BOOLEAN")  ? TDC_CF_BOOLEAN  :\
  !strcmp(txt,"XML")      ? TDC_CF_XML :\
  TDC_CF_NULL )

#define getCompoundFormatType(txt) (\
  !strcmp(txt,"NAME16FLTINT") ? TDC_CF_CHAR16FI :\
  !strcmp(txt,"NAME16FI") ? TDC_CF_CHAR16FI :\
  !strcmp(txt,"CHAR16FI") ? TDC_CF_CHAR16FI :\
  !strcmp(txt,"NAME8I")   ? TDC_CF_CHAR8I :\
  !strcmp(txt,"CHAR8I")   ? TDC_CF_CHAR8I :\
  !strcmp(txt,"NAME16I")  ? TDC_CF_CHAR16I :\
  !strcmp(txt,"CHAR16I")  ? TDC_CF_CHAR16I :\
  !strcmp(txt,"NAME32I")  ? TDC_CF_CHAR32I :\
  !strcmp(txt,"CHAR32I")  ? TDC_CF_CHAR32I :\
  !strcmp(txt,"NAME48I")  ? TDC_CF_CHAR48I :\
  !strcmp(txt,"CHAR48I")  ? TDC_CF_CHAR48I :\
  !strcmp(txt,"NAME64I")  ? TDC_CF_CHAR64I :\
  !strcmp(txt,"CHAR64I")  ? TDC_CF_CHAR64I :\
  !strcmp(txt,"HITTS")    ? TDC_CF_HITTS :\
  !strcmp(txt,"FI")       ? TDC_CF_FI :\
  !strcmp(txt,"FLTINT")   ? TDC_CF_FI :\
  !strcmp(txt,"FLTDBL")   ? TDC_CF_FLTDBL :\
  !strcmp(txt,"II")       ? TDC_CF_II :\
  !strcmp(txt,"INTINT")   ? TDC_CF_II :\
  !strcmp(txt,"LI")       ? TDC_CF_II :\
  !strcmp(txt,"LNGINT")   ? TDC_CF_II :\
  !strcmp(txt,"LNGDBL")   ? TDC_CF_LNGDBL :\
  !strcmp(txt,"INTDBL")   ? TDC_CF_LNGDBL :\
  !strcmp(txt,"DBLDBL")   ? TDC_CF_DBLDBL :\
  !strcmp(txt,"NAMEDBLDBL") ? TDC_CF_NAMEDBLDBL :\
  !strcmp(txt,"NAME16DBLDBL") ? TDC_CF_NAMEDBLDBL :\
  !strcmp(txt,"NAME32DBLDBL") ? TDC_CF_NAME32DBLDBL :\
  !strcmp(txt,"NAME64DBL") ? TDC_CF_NAME64DBL :\
  !strcmp(txt,"NAME64DBLDBL") ? TDC_CF_NAME64DBLDBL :\
  !strcmp(txt,"NAME64DBLDBLDBL") ? TDC_CF_NAME64DBLDBLDBL :\
  !strcmp(txt,"NAME16II") ? TDC_CF_NAME16II :\
  !strcmp(txt,"CHAR16II") ? TDC_CF_NAME16II :\
  !strcmp(txt,"NAME16INTINT") ? TDC_CF_NAME16II :\
  !strcmp(txt,"DBLDBLDBL")   ? TDC_CF_DBLDBLDBL :\
  !strcmp(txt,"TDS")      ? TDC_CF_TDS :\
  !strcmp(txt,"IFI")      ? TDC_CF_TDS :\
  !strcmp(txt,"INTFLTINT")? TDC_CF_TDS :\
  !strcmp(txt,"USTRING")  ? TDC_CF_USTRING :\
  !strcmp(txt,"XYS")      ? TDC_CF_XYS :\
  !strcmp(txt,"FFI")      ? TDC_CF_XYS :\
  !strcmp(txt,"FLTFLTINT")? TDC_CF_XYS :\
  !strcmp(txt,"FLTINTINT")? TDC_CF_FII :\
  !strcmp(txt,"FIS")      ? TDC_CF_FII :\
  !strcmp(txt,"FILTER")   ? TDC_CF_FILTER :\
  !strcmp(txt,"IFFF")     ? TDC_CF_IFFF :\
  !strcmp(txt,"INTFLTFLTFLT")? TDC_CF_IFFF :\
  !strcmp(txt,"SPECTRUM") ? TDC_CF_SPECTRUM :\
  !strcmp(txt,"ASPECTRUM") ? TDC_CF_SPECTRUM :\
  !strcmp(txt,"ADDRESS")  ? TDC_CF_ADDRESS  :\
  !strcmp(txt,"INTINTINTINT")? TDC_CF_ADDRESS  :\
  !strcmp(txt,"IIII")     ? TDC_CF_ADDRESS  :\
  !strcmp(txt,"INTINTINT")? TDC_CF_III  :\
  !strcmp(txt,"III")      ? TDC_CF_III  :\
  !strcmp(txt,"WINDOW")   ? TDC_CF_WINDOW  :\
  !strcmp(txt,"TTII")     ? TDC_CF_WINDOW  :\
  !strcmp(txt,"POINT")    ? TDC_CF_POINT  :\
  !strcmp(txt,"XY")       ? TDC_CF_POINT  :\
  !strcmp(txt,"FLTFLT")   ? TDC_CF_POINT  :\
  !strcmp(txt,"TDSI")     ? TDC_CF_TDSI  :\
  !strcmp(txt,"INTFLTSHTSHT")? TDC_CF_TDSI  :\
  !strcmp(txt,"DEFAULT")  ? TDC_CF_DEFAULT :\
  !strcmp(txt,"IIFF")     ? TDC_CF_IIFF :\
  !strcmp(txt,"INTINTFLTFLT")? TDC_CF_IIFF :\
  !strcmp(txt,"FIFI")     ? TDC_CF_FIFI :\
  !strcmp(txt,"FLTINTFLTINT")? TDC_CF_FIFI :\
  !strcmp(txt,"FWINDOW")   ? TDC_CF_FWINDOW  :\
  !strcmp(txt,"IFFFNAME")   ? TDC_CF_IFFFNAME  :\
  !strcmp(txt,"INTFLTFLTFLTNAME") ? TDC_CF_IFFFNAME  :\
  !strcmp(txt,"UNAME") ? TDC_CF_IFFFNAME  :\
  !strcmp(txt,"BITFIELD8") ? TDC_CF_BITFIELD8  :\
  !strcmp(txt,"BITFIELD16") ? TDC_CF_BITFIELD16 :\
  !strcmp(txt,"BITFIELD32") ? TDC_CF_BITFIELD32 :\
  !strcmp(txt,"IMAGE") ? TDC_CF_IMAGE :\
  !strcmp(txt,"HISTORY") ? TDC_CF_HISTORY :\
  TDC_CF_NULL )

#define TDC_CM_NULL         0x00
#define TDC_CM_CANCEL       0x00
#define TDC_CM_SINGLE       0x01
#define TDC_CM_REFRESH      0x02
#define TDC_CM_DATACHANGE   0x02
#define TDC_CM_POLL         0x03
#define TDC_CM_TIMER        0x03
#define TDC_CM_REGISTER     0x04
#define TDC_CM_RECEIVE      0x05
#define TDC_CM_EVENT        0x06
#define TDC_CM_NODUPLICATES 0x10
#define TDC_CM_SEEKPATTERN  0x20
#define TDC_CM_MISSPATTERN  0x40
#define TDC_CM_STREAM       0x80
#define TDC_CM_BCAST        0x200
#define TDC_CM_NETWORK      0x200
#define TDC_CM_MCAST        0x200
#define TDC_CM_USE_ON_ERROR 0x400
#define TDC_CM_USEONERROR   0x400
#define TDC_CM_RETRY        0x800
#define TDC_CM_GROUPED      0x1000
#define TDC_CM_CONNECT      0x2000
#define TDC_CM_WAIT         0x4000
#define TDC_CM_SYNCNOTIFY   0x8000

#define BASEMODE(m)  ((m) & 0x07)
#define TARGETMODE(m)  ((m) & 0x0f7f)
#define TDC_CM_REMOVEVOLATILE (TDC_CM_NODUPLICATES|TDC_CM_SEEKPATTERN|TDC_CM_MISSPATTERN|TDC_CM_USEONERROR|TDC_CM_GROUPED|TDC_CM_WAIT)

#define getAccessMode(txt) (\
	strstr(txt,"READ")    ? TDC_CM_SINGLE :\
	strstr(txt,"WRITE")   ? TDC_CM_SINGLE :\
	strstr(txt,"SINGLE")  ? TDC_CM_SINGLE :\
	strstr(txt,"REFRESH") ? TDC_CM_REFRESH :\
	strstr(txt,"DATACHANGE") ? TDC_CM_REFRESH :\
	strstr(txt,"POLL")    ? TDC_CM_POLL :\
	strstr(txt,"TIMER")   ? TDC_CM_POLL :\
	strstr(txt,"REGISTER")? TDC_CM_REGISTER :\
	strstr(txt,"RECEIVE") ? TDC_CM_RECEIVE :\
	strstr(txt,"EVENT")   ? TDC_CM_EVENT :\
	TDC_CM_CANCEL )
short getTransferMode(char *mod);
extern char *modetoa[];
TINE_EXPORT char *GetModeAsString(int transferMode);
TINE_EXPORT short GetTransferMode(char *mod);

#define TDC_CA_NULL         0x00
#define TDC_CA_READ         0x01
#define TDC_CA_WRITE        0x02
#define TDC_CA_REPEAT       0x04
#define TDC_CA_SYNC         0x08
#define TDC_CA_ALARM        0x10
#define TDC_CA_HIST         0x20
#define TDC_CA_FIRST        0x40
#define TDC_CA_LAST         0x80
#define TDC_CA_RETRY        0x100
#define TDC_CA_NETWORK      0x200
#define TDC_CA_QUERY        0x400
#define TDC_CA_CCSHOWALL    0x400 
#define TDC_CA_LOCKED       0x800
#define TDC_CA_XREAD        0x800
#define TDC_CA_STREAM       0x800
#define TDC_CA_NORETRY      0x1000
#define TDC_CA_NOSYNC       0x1000 
#define TDC_CA_CONNECT      0x2000
#define TDC_CA_MUTABLE      0x4000
#define TDC_CA_SYNCNOTIFY   0x8000

#define getAccessType(txt) ( strstr(txt,"WRITE") ? TDC_CA_WRITE : TDC_CA_READ )

short ftoi(char *fmt);
#define getFormatType(f) ftoi(f)
char *itof(int fmt);
short mtoi(char *mod);
char *itom(short accessMode);
TINE_EXPORT char *GetFormatAsString(int fmt);
TINE_EXPORT short GetFormatFromString(char *fmt);

#define TDC_GT_LIN  0
#define TDC_GT_LOG  1
#define TDC_GT_SLOG 2
#define TDC_GT_TD   3
#define TDC_GT_BIT  4
#define TDC_GT_TEXT 5
#define TDC_GT_ABS  6
#define TDC_GT_HEX  7

#define getGraphType(txt) (\
  txt == NULL           ? TDC_GT_LIN:\
  strstr(txt,"LIN")     ? TDC_GT_LIN :\
  strstr(txt,"LOG")     ? TDC_GT_LOG :\
  strstr(txt,"SLOG")    ? TDC_GT_SLOG :\
  strstr(txt,"TD")      ? TDC_GT_TD :\
  strstr(txt,"BIT")     ? TDC_GT_BIT :\
  strstr(txt,"TEXT")    ? TDC_GT_TEXT :\
  strstr(txt,"ABS")     ? TDC_GT_ABS :\
  strstr(txt,"HEX")     ? TDC_GT_HEX :\
  TDC_GT_LIN )

#define TDC_AT_UNKNOWN      0x00
#define TDC_AT_SCALAR       0x01
#define TDC_AT_SINGLE       0x02
#define TDC_AT_DOUBLE       0x04
#define TDC_AT_BOOLEAN      0x08
#define TDC_AT_CHANNEL      0x10
#define TDC_AT_SPECTRUM     0x20
#define TDC_AT_TRACE        0x20
#define TDC_AT_WAVEFORM     0x20
#define TDC_AT_STRUCTURED   0x40
#define TDC_AT_COLLECTION   0x40
#define TDC_AT_UNSTRUCTURED 0x80
#define TDC_AT_BLOB         0x80
#define TDC_AT_IMAGE        0x80
#define TDC_AT_JPEG        0x100
#define TDC_AT_MPEG        0x200
#define TDC_AT_BMP         0x400
#define TDC_AT_GIF         0x800
#define TDC_AT_WAV        0x1000
#define TDC_AT_MP3        0x2000

short getArrayType(char *fmt);
short getArrayRowLength(char *fmt);

/* image format definitions */
#define TDC_IF_GRAY   0
#define TDC_IF_RGB    1
#define TDC_IF_RGBA   2
#define TDC_IF_RGB15  3
#define TDC_IF_RGB16  4
#define TDC_IF_JPEG   5
#define TDC_IF_TIFF   6
#define TDC_IF_YUV411 7
#define TDC_IF_YUV422 8
#define TDC_IF_YUV444 9
#define TDC_IF_HUFFYUV 10
#define TDC_IF_BITMAP 11

/* image flags */
#define TDC_IFLG_LITTLE_ENDIAN   0x1
#define TDC_IFLG_LOSSLESS_COMP   0x2
#define TDC_IFLG_HORIZONTAL_FLIP 0x4
#define TDC_IFLG_VERTICAL_FLIP   0x8

/* property signals */
#define TDC_PS_NONE    0x00 /**< NULL signal */
#define TDC_PS_ACCESS  0x01 /**< property is being accessed by a caller */
#define TDC_PS_RETRY   0x02 /**< property is being retried */
#define TDC_PS_LATE    0x04 /**< property is being returned late */
#define TDC_PS_PENDING 0x08 /**< property is being called while last transmission still pending */
#define TDC_PS_SENT    0x10 /**< property has been sent to caller */
#define TDC_PS_ALL     0xff /**< signal on any event */

#endif /* !defined TINE_DECORATED_CONSTANTS */


#define ENSTAG        "ENS"
#define CSHOSTS       "ENSEQM"
#define CSHOSTS_FILE  "cshosts.csv"
#define FECID_FILE    "fecid.csv"
#define EXPORT_FILE   "exports.csv"
#define EQPDB_FILE    "eqpdbase.csv"
#define FECDB_FILE    "fecaddr.csv"
#define USERS_FILE    "users.csv"
#define DENYUSER_FILE "denyuser.csv"
#define IPNETS_FILE   "ipnets.csv"
#define IPBCASTNETS_FILE "ipbcast.csv"
#define IPXNETS_FILE  "ipxnets.csv"
#define IPXBCASTNETS_FILE "ipxbcast.csv"
#define ALIAS_FILE    "alias.csv"

#define FECNAME_UNKNOWN "*unknown*"

#define MAJOR_VERSION 4
#define MINOR_VERSION 2
#define VERSION_REVISION 0

#if defined(__cplusplus) && !defined(FORCE_CPP)
}
#endif

#endif /* _TINEDEFS_H_ */
